package speiger.src.collections.shorts.functions.function;

import java.util.function.BiFunction;

/**
 * A Type Specific Unary Operator to support Compute/Merge functions with type specific methods to reduce boxing/unboxing
 */
public interface ShortIntUnaryOperator extends BiFunction<Short, Integer, Integer>
{
	/**
	 * A Type Specifc apply method to reduce boxing/unboxing.
	 * Applies this function to the given arguments.
	 *
	 * @param k the first function argument
	 * @param v the second function argument
	 * @return the function result
	 */
	public int applyAsInt(short k, int v);
	
	@Override
	public default Integer apply(Short k, Integer v) { return Integer.valueOf(applyAsInt(k.shortValue(), v.intValue())); }
}